From 725d37b2b862b662e4f6d35d8066af08ab331e49 Mon Sep 17 00:00:00 2001
From: basos g <noxelia 4t gmail d0t c0m>
Date: Fri, 3 Apr 2009 00:15:11 +0000
Subject: [PATCH 16/20] Add some compile time assertions for the module list parameters

When a list parameter on the affected macros is NULL VLC might
crash silently producing possible gray hair.
This is a compile time check to assert correct ussage of the macros
---
 include/vlc_plugin.h |    8 +++++++-
 1 files changed, 7 insertions(+), 1 deletions(-)

diff --git a/include/vlc_plugin.h b/include/vlc_plugin.h
index f9e3107..53a1b10 100644
--- a/include/vlc_plugin.h
+++ b/include/vlc_plugin.h
@@ -397,20 +397,26 @@ enum vlc_module_properties
 #define change_short( ch ) \
     vlc_config_set (p_config, VLC_CONFIG_SHORTCUT, (int)(ch));
 
+#define compile_time_assert(cond, msg) \
+    extern char msg[(cond) ? 1 : -1] ;
+
 #define change_string_list( list, list_text, list_update_func ) \
-    vlc_config_set (p_config, VLC_CONFIG_LIST, domain, \
+   compile_time_assert( list, change_string_list_list_paremeter_cannot_be_NULL ) \
+   vlc_config_set (p_config, VLC_CONFIG_LIST, domain, \
                     (size_t)(sizeof (list) / sizeof (char *)), \
                     (const char *const *)(list), \
                     (const char *const *)(list_text), \
                     (vlc_callback_t)(list_update_func));
 
 #define change_integer_list( list, list_text, list_update_func ) \
+    compile_time_assert( list, change_integer_list_list_paremeter_cannot_be_NULL ) \
     vlc_config_set (p_config, VLC_CONFIG_LIST, domain, \
                     (size_t)(sizeof (list) / sizeof (int)), \
                     (const int *)(list), \
                     (const char *const *)(list_text), \
                     (vlc_callback_t)(list_update_func));
 
+
 #define change_integer_range( minv, maxv ) \
     vlc_config_set (p_config, VLC_CONFIG_RANGE, (int)(minv), (int)(maxv));
 
-- 
1.6.1.3

